CREATE TABLE `goods_info`
(
    `id`               bigint        NOT NULL auto_increment COMMENT '主键ID',
    `type`             char(1)       NOT NULL default '0' COMMENT '运营商 0：未标注 1：电信 2：联通 3：移动 4：光电',
    `name`             varchar(255)  NOT NULL COMMENT '商品名',
    `main_pic`         varchar(1000) NOT NULL COMMENT '主图',
    `little_picture`   varchar(1000)          DEFAULT '' COMMENT '详情图',
    `netAddr`          VARCHAR(255)           DEFAULT '' COMMENT '商品套餐资料介绍地址',
    `area`             VARCHAR(10)            DEFAULT '' COMMENT '归属地',

    `uni_flow`         VARCHAR(10)            DEFAULT '' COMMENT '通用流量',
    `dir_flow`         VARCHAR(10)            DEFAULT '' COMMENT '定向流量',
    `talk_time`        VARCHAR(10)            DEFAULT '' COMMENT '通话时间',

    `disable_area`     VARCHAR(1000)          DEFAULT '' COMMENT '禁发地区',
    `disable_age`      VARCHAR(100)           DEFAULT '' COMMENT '年龄限制',
    `disable_contract` VARCHAR(10)            DEFAULT '' COMMENT '合约期',
    `notes`            text COMMENT '商品说明',

    `api_id`           bigint                 DEFAULT NULL COMMENT '三方接口',
    `api_product_id`   bigint                 DEFAULT NULL COMMENT '三方商品id',
    `number_sel`       char(1)       NOT NULL DEFAULT '0' COMMENT '是否选号 0：不支持 1：收货地不是归属地 2：收货地是归属地',
    `status`           char(1)       NOT NULL DEFAULT '0' COMMENT '状态 0：上架 1：下架',
    `create_time`      datetime      NOT NULL default current_timestamp() comment '创建时间',
    `update_time`      datetime      NOT NULL default current_timestamp() on update current_timestamp() comment '更新时间',
    `remarks`          VARCHAR(255)           DEFAULT NULL COMMENT '备注',
    primary key (id)
) COMMENT '商品列表 ';