package order_info

import "github.com/zeromicro/go-zero/core/stores/sqlx"

var _ OderInfoModel = (*customOderInfoModel)(nil)

type (
	// OderInfoModel is an interface to be customized, add more methods here,
	// and implement the added methods in customOderInfoModel.
	OderInfoModel interface {
		oderInfoModel
		withSession(session sqlx.Session) OderInfoModel
	}

	customOderInfoModel struct {
		*defaultOderInfoModel
	}
)

// NewOderInfoModel returns a model for the database table.
func NewOderInfoModel(conn sqlx.SqlConn) OderInfoModel {
	return &customOderInfoModel{
		defaultOderInfoModel: newOderInfoModel(conn),
	}
}

func (m *customOderInfoModel) withSession(session sqlx.Session) OderInfoModel {
	return NewOderInfoModel(sqlx.NewSqlConnFromSession(session))
}
