package httpUtil

import (
	"fmt"
	"testing"
)

func TestRequest(t *testing.T) {
	// 创建 PostRequest 实例
	postRequest := NewRequest()

	// 示例：发送 JSON 请求
	url := "https://example.com/api"
	headers := map[string]string{
		"Authorization": "Bearer your_token",
	}
	body := map[string]interface{}{
		"key1": "value1",
		"key2": "value2",
	}

	// 发送 JSON 请求
	resp, err := postRequest.SendJSON(url, headers, body)
	if err != nil {
		fmt.Println("发送请求失败:", err)
		return
	}

	fmt.Println("响应内容:", resp)

	// 示例：发送 form-data 请求
	formParams := map[string]string{
		"user_id":    "your_user_id",
		"product_id": "12345",
	}
	resp2, err := postRequest.SendFormData(url, headers, formParams)
	if err != nil {
		fmt.Println("发送 form-data 请求失败:", err)
		return
	}

	fmt.Println("响应内容:", resp2)
}
