package api

import (
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"
	"hk/service/api/internal/logic/api"
	"hk/service/api/internal/svc"
	"hk/service/api/internal/types"
)

func TiktokInfoHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.TiktokReq
		if err := httpx.Parse(r, &req); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := api.NewTiktokInfoLogic(r.Context(), svcCtx)
		resp, err := l.TiktokInfo(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
