package svc

import (
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/rest"
	"hk/model/config_api"
	"hk/model/goods_info"
	"hk/model/goods_status"
	"hk/service/api/internal/config"
	"hk/service/api/internal/middleware"
)

type ServiceContext struct {
	Config           config.Config
	RealIPMiddleware rest.Middleware
	ConfigApiModel   config_api.ConfigApiModel
	GoodsStatusModel goods_status.GoodsStatusModel
	GoodsInfoModel   goods_info.GoodsInfoModel
}

func NewServiceContext(c config.Config) *ServiceContext {
	return &ServiceContext{
		Config:           c,
		RealIPMiddleware: middleware.NewRealIPMiddleware().Handle,
		ConfigApiModel:   config_api.NewConfigApiModel(sqlx.NewMysql(c.Mysql.DataSource)),
		GoodsStatusModel: goods_status.NewGoodsStatusModel(sqlx.NewMysql(c.Mysql.DataSource)),
		GoodsInfoModel:   goods_info.NewGoodsInfoModel(sqlx.NewMysql(c.Mysql.DataSource)),
	}
}
